
#pragma once


#include "lib_jst.h"

namespace TG
{


struct GMSPRITE_PARTS_COLLISION_SPHERE_JST_PARAMS
{
	JST_F32		afCol_SphereCenter[2];
	JST_F32		fCol_SphereRadius;
	JST_BOOL	bCollisionEnable;

	JST_I32		aIntParams[2];
	JST_F32		aFloatParams[2];
};

struct GMSPRITE_PARTS_COLLISION_CAPSULE_JST_PARAMS
{
	JST_F32		afCol_CapsuleBegin[2];
	JST_F32		afCol_CapsuleEnd[2];
	JST_F32		fCol_CapsuleRadius;
	JST_BOOL	bCollisionEnable;

	JST_I32		aIntParams[2];
	JST_F32		aFloatParams[2];
};

struct GMSPRITE_PARTS_JST_PARAMS
{
	JST_STRING		SpriteName;			// ȂAp[cȂNULL{[
	JST_STRING		ParentName;

	JST_U32			Generation;
	JST_U32			PartsIndex;
	JST_BOOL		bFloatBone;

	JST_F32			afPt[2];
//	JST_F32			afScale[2];
	JST_F32			fRotation;
	JST_F32			fBoneLength;
	JST_U32			BoneWidth;

	JST_F32			afImagePt[2];
	JST_F32			afImageScale[2];
	JST_F32			fImageRotation;

	JST_BOOL		bCancelChildrenMoving;
	JST_BOOL		bCancelChildrenScaling;
	JST_BOOL		bCancelChildrenRotation;
	JST_BOOL		bSaturation;
	JST_BOOL		bAA;
	JST_BOOL		bReverseH;
	JST_BOOL		bReverseV;

	JST_U32			Col_SphereCount;	// NAME + PARTS_NAME + COL_SPH_%03d Ƃp[^A^b`
	JST_U32			Col_CapsuleCount;	// NAME + PARTS_NAME + COL_CAP_%03d Ƃp[^A^b`

	JST_U32			Priority;
	JST_BOOL		bAutoAnimation;
	JST_U32			AnimationCount;		// 0Ȃanimation off
	JST_U32			AnimationWidth;
	JST_U32			AnimationHeight;
	JST_F32			fAnimationAutoStep;
	JST_BOOL		bAnimationAutoLoop;

	JST_BOOL		bMatrixAnimation;
	JST_U32			MatrixAnimationRow;

	JST_U32			ImageColor;
	JST_BOOL		bImageVisible;
	JST_U32			AnimationFrame;
	JST_BOOL		bAnimationIP;
	JST_BOOL		bCollisionEnable;

	JST_I32			aMetaDataIntParams[8];
	JST_F32			aMetaDataFloatParams[8];
	JST_STRING		strMetaDataParams;

};

// IKp[^
// GMSPRITE_PARTS_JST_PARAMS̃GNXehf[^
// GMSPRITE_PARTS_JST_PARAMS̃f[^(=p[c)_IKt̂tB
struct GMSPRITE_PARTS_IK_JST_PARAMS
{
	JST_BOOL		bIKEnable;
	JST_BOOL		bIKLimitBoneRotate;
	JST_BOOL		bIKBoneLength;
	JST_F32			fIKLimitRotateP;			// vX]
	JST_F32			fIKLimitRotateM;			// }CiX]AŋLq
	JST_F32			fIKLimitBoneLengthMin;
	JST_F32			fIKLimitBoneLengthMax;
	JST_F32			fIKWeight;
};

struct GMSPRITE_MOTION_JST_PARAMS
{
	JST_U32			MaxFrame;

	JST_U32			KeyElementCount;
	JST_U32			EventElementCount;

	JST_BOOL		bSplineMove_Bone;
	JST_BOOL		bSplineMove_Image;
	JST_BOOL		bLoop;
	JST_F32			fFPSScale;
	JST_BOOL		bCollisionEnable;
	JST_BOOL		bDisableLastFrame;
	JST_BOOL		bEnableIK;		// ̃[VIKL
};

// Cxg\
struct GMSPRITE_MOTION_EVENT_PARTS_JST_PARAMS
{
	JST_U32			Frame;
	JST_U32			Type;
	JST_U32			Option;
	JST_STRING		PartsName;
	JST_STRING		Event;
};

// MotionName + "_Key%1d"ƂOɂȂ %1d0`GMSPRITE_MOTION_JST_PARAMS.KeyElementCount
struct GMSPRITE_MOTION_KEYFRAME_PARTS_JST_PARAMS
{
	JST_STRING		PartsName;
	JST_U32			KeyNumber;

	JST_F32			afPt[2];
	JST_F32			fRotation;
	JST_F32			fBoneLength;

	JST_F32			afImagePt[2];
	JST_F32			afImageScale[2];
	JST_F32			fImageRotation;

	JST_U32			Priority;
	JST_U32			ManualAnimationFrame;
	JST_BOOL		bAnimationIP;				// 蓮Ajt[ԂB

	JST_U32			MatrixAnimationRow;

	JST_F32			afColor[4];
	JST_BOOL		bVisible;
	JST_BOOL		bCollisionEnable;
	JST_BOOL		bDisable;

	JST_BOOL		bReverseH;
	JST_BOOL		bReverseV;

//	JST_STRING		EventName;				// GWɕ񂪒ʒmB

	JST_U32			CollisionCount;
	JST_F32			afColParams[192];		// MaxCol each Parts32 * 6p[^
};


struct GMSPRITE_PARTS_NAME_JST_PARAMS
{
	JST_STRING		PartsName;
};

struct GMSPRITE_MESHED_IMAGE_NAME_JST_PARAMS
{
	JST_STRING		MeshedImageName;
};

struct GMSPRITE_PARTS_ARRAY_JST_PARAMS
{
	JST_U32			PartsCount;
	JST_STRING		PartsNameTemplete;		// s萔̃p[c񋓂邽߂̃Tu\̉
	JST_U32			MeshedImageCount;		// bVC[W
	JST_STRING		MeshedImageTemplete;
};

struct GMSPRITE_MOTION_NAME_JST_PARAMS
{
	JST_STRING		MotionName;
};

struct GMSPRITE_COMBO_MOTION_NAME_JST_PARAMS
{
	JST_STRING		ComboMotionName;
};

struct GMSPRITE_COMBO_MOTION_JST_PARAMS
{
	JST_U32			MotionCount;
	JST_BOOL		bMotionSetTotalLoop;
};

struct GMSPRITE_COMBO_MOTION_LEAF_JST_PARAMS	// combo_motion_name_%1dɌŒ
{
	JST_STRING		strMotionName;
	JST_BOOL		bEnable;
	JST_I32			iLoopCount;
	JST_U32			IPFrame;
};

struct GMSPRITE_MOTIONS_ARRAY_JST_PARAMS
{
	JST_U32			MotionCount;
	JST_U32			ComboMotionCount;		// combo_name_%1dɌŒ
};

struct GMSPRITE_JST_PARAMS
{
	JST_STRING		PartsJSTName;
	JST_F32			fScale;		// _XP[1͉sNZw
								// 1ȂsNZB\{ł͂Ȃ̂ŒӁBRWTCYA3DƂ̍W킹ȂǁB
	JST_F32			fFps;
	JST_U32			Priority;
	JST_BOOL		bForceSat;
	JST_BOOL		bForceAlpha;
	JST_BOOL		bForceAA;
	JST_BOOL		bForceNoAA;
	JST_BOOL		bReverseH;
	JST_BOOL		bReverseV;

	JST_I32			aMetaDataIntParams[8];
	JST_F32			aMetaDataFloatParams[8];
	JST_STRING		strMetaDataParams;

	JST_STRING		strExclusiveEffectFilePath;
	JST_STRING		strExclusiveSoundFilePath;

	JST_U32			CommonEffectSetCount;
	JST_U32			CommonSoundSetCount;
};

struct GMSPRITE_COMMON_RESOURCE_JST_PARAMS
{
	JST_STRING		strName;
	JST_STRING		strFilePath;
};

// c[̃GfBbgpݒlAf[^̂̂ɂ͊֌WȂ
struct GMSPRITE_EDIT_JST_PARAMS
{
	JST_F32			fViewPosX;
	JST_F32			fViewPosY;
	JST_F32			fZoom;

	JST_STRING		CurrentMotionName;
};


struct GMSPRITE_MESHED_IMAGE_JST_PARAMS
{
	JST_U32				Mesh_WidthPointCount;
	JST_U32				Mesh_HeightPointCount;

	JST_STRING			Mesh_ImagePath;					// C[W̃vWFNg΃pX

	JST_U32				Mesh_ImageColor;
	JST_BOOL			bMesh_Visible;
	JST_U32				Mesh_AnimationFrame;
	JST_BOOL			bMesh_AnimationIP;
	JST_BOOL			bMesh_Satulation;
	JST_BOOL			bMesh_AA;
	JST_BOOL			bMesh_ReverseH;
	JST_BOOL			bMesh_ReverseV;
	JST_U32				Mesh_AnimationCount_Current;			// Aj[Vݒ
	JST_U32				Mesh_AnimationCount_Max;
	JST_U32				Mesh_AnimationWidth;
	JST_U32				Mesh_AnimationHeight;
	JST_BOOL			bMesh_Animation;
	JST_BOOL			bMesh_AnimationAutoPlay;
	JST_BOOL			bMesh_AnimationAutoLoop;
	JST_F32				fMesh_AnimationAutoStep;
	JST_BOOL			bMesh_MatrixAnimation;
	JST_U32				Mesh_MatrixAnimationRow;

	JST_U32				FixDistortion;
	JST_U32				SubMeshIPType;
	JST_U32				MeshIndex;

	JST_STRING			astrAttachedBoneNames[ 16 ];

	JST_F32				vPosition[2];
	JST_F32				vScale[2];
	JST_F32				fRotation;

	JST_U32				SubPriority;

	JST_I32				aMetaDataIntParams[8];
	JST_F32				aMetaDataFloatParams[8];
	JST_STRING			strMetaDataParams;

};

struct GMSPRITE_MESHED_IMAGE_POINT_JST_PARAMS
{
	JST_F32		vPos[2];
	JST_F32		vUV[2];

	JST_BOOL	abEnabledBones[16];
	JST_F32		afWeights[16];
};

};


