
#pragma once


#include "lib_jst.h"

namespace TG
{

struct EFFECT_SET_JST_PARAMS
{
	JST_U32			Count;
};

struct PARTICLE_EFFECT_JST_PARAMS
{
	JST_BOOL		bEnable;
	JST_STRING		strDefineName;

	JST_U32			Priority;
	JST_F32			fTotalScale;
	JST_F32			fTotalTimeScale;
	JST_BOOL		bSyncMove;
	JST_BOOL		bSyncRotate;
	JST_BOOL		bSyncScale;
};

struct PARTICLE_RESOURCE_COUNT_JST_PARAMS
{
	JST_U32			SpriteFileCount;
	JST_U32			SoundFileCount;
	JST_U32			AutoLoadResouces;
};

struct PARTICLE_RESOURCE_JST_PARAMS
{
	JST_STRING		ResourceFile;
};

struct PARTICLE_JST_PARAMS
{
	JST_BOOL		bEnable;
	JST_U32			ElementCount_Base;
	JST_U32			ElementCount_Volume;
	JST_F32			fConeAngle_Base;
	JST_F32			fConeAngle_Volume;
	JST_F32			fPlaceRadius_Base;
	JST_F32			fPlaceRadius_Volume;
	JST_F32			fDelayTime;

	JST_F32			fScaleBegin_Base;
	JST_F32			fScaleBegin_Volume;
	JST_F32			fScaleEnd_Base;
	JST_F32			fScaleEnd_Volume;
	JST_F32			fGravityX;
	JST_F32			fGravityY;
	JST_U32			ColorBegin;
	JST_U32			ColorMiddle;
	JST_U32			ColorEnd;

	JST_U32			SatAA;
	JST_F32			fVelocity_Base;
	JST_F32			fVelocity_Volume;
	JST_F32			fDecelerate_Base;
	JST_F32			fDecelerate_Volume;
	JST_U32			FirstRotate;
	JST_F32			fRotationBegin_Base;
	JST_F32			fRotationBegin_Volume;
	JST_F32			fAngularV_Base;
	JST_F32			fAngularV_Volume;
	JST_F32			fAngularD_Base;
	JST_F32			fAngularD_Volume;
	JST_BOOL		bRandomRotDir;
	JST_F32			fLifeTime_Base;
	JST_F32			fLifeTime_Volume;
	JST_F32			fFadeTime_Base;
	JST_F32			fFadeTime_Volume;
	JST_F32			fMaxDelayTime;
	JST_F32			fSoundDelayTime;

	JST_STRING		SoundName;

	JST_STRING		aResourceNames[4];
	JST_BOOL		abElementIsParticles[4];
	JST_F32			aRates[4];
	JST_U32			aPriorities[4];
	JST_F32			aRotOffset[4];
	JST_F32			aAnimationTimeRatio[4];
};


};


